function varargout = Franken_method_multiple(varargin)
% FRANKEN_METHOD_MULTIPLE MATLAB code for Franken_method_multiple.fig
%      FRANKEN_METHOD_MULTIPLE, by itself, creates a new FRANKEN_METHOD_MULTIPLE or raises the existing
%      singleton*.
%
%      H = FRANKEN_METHOD_MULTIPLE returns the handle to a new FRANKEN_METHOD_MULTIPLE or the handle to
%      the existing singleton*.
%
%      FRANKEN_METHOD_MULTIPLE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FRANKEN_METHOD_MULTIPLE.M with the given input arguments.
%
%      FRANKEN_METHOD_MULTIPLE('Property','Value',...) creates a new FRANKEN_METHOD_MULTIPLE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Franken_method_multiple_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Franken_method_multiple_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Franken_method_multiple

% Last Modified by GUIDE v2.5 06-Jul-2018 10:32:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Franken_method_multiple_OpeningFcn, ...
                   'gui_OutputFcn',  @Franken_method_multiple_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Franken_method_multiple is made visible.
function Franken_method_multiple_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Franken_method_multiple (see VARARGIN)

% Choose default command line output for Franken_method_multiple
handles.output = hObject;

change_materials_units(hObject, eventdata, handles);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Franken_method_multiple wait for user response (see UIRESUME)
% uiwait(handles.figure1);


function clear_output(hObject, eventdata, handles)
%



% --- Outputs from this function are returned to the command line.
function varargout = Franken_method_multiple_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_return.
function pushbutton_return_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_return (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(Franken_method_multiple);


% --- Executes on button press in pushbutton_calculate.
function pushbutton_calculate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

disp(' ');
disp(' * * * * * * * * * * * * * * * * * * * * * * ');
disp(' ');

fig_num=1;


iu=get(handles.listbox_units,'Value');

N=get(handles.listbox_num,'Value');

get_table_data(hObject, eventdata, handles)


shell_name=getappdata(0,'shell_name');
SPL_name=getappdata(0,'SPL_name');
fring=getappdata(0,'fring');
diam=getappdata(0,'diam');
smd=getappdata(0,'smd');
PSD_name=getappdata(0,'PSD_name');


grms=zeros(N,1);
grmsb=zeros(N,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n_type=1;  % one-third octave
 

for i=1:N
    
    out1=sprintf(' %d  %s ',i,SPL_name{i});
    disp(out1);
    
    try
        THM=evalin('base',SPL_name{i});
    catch
        warndlg('Input SPL not found');
        return;
    end

    f=THM(:,1);
    dB=THM(:,2);

    [fig_num]=spl_plot(fig_num,n_type,f,dB);
    
    
    stationdiam=diam(i);
    
    if(iu==1)
        stationdiam=stationdiam/12.;  % convert inches to feet
    else
        stationdiam=stationdiam*3.28;  % convert meters to feet    
    end
    stationdiam_ft=stationdiam;
    
    rf=fring(i);
    W=smd(i);

    if(iu==2)   
        W=W*0.2048;  % convert from kg/m^2 to lbm/ft^2
    end
    W_lbm_per_ft2=W;
    
    [psd,grms(i),grmsb(i)]=Franken_function_alt_grms(stationdiam_ft,W_lbm_per_ft2,rf,f,dB); 
%

    Wa=[f psd];
    fmin=f(1);


    t_string = sprintf(' Acceleration Power Spectral Density  \n %s  %7.3g GRMS Overall',shell_name{i},grms(i));
    x_label='Frequency (Hz)';
    y_label='Accel (G^2/Hz)';
    fmax=2000;

    ppp=Wa;
    md=6;

    [fig_num]=plot_loglog_function_md(fig_num,x_label,y_label,t_string,ppp,fmin,fmax,md);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    t_string = sprintf(' Acceleration Power Spectral Density  \n %s  %7.3g GRMS Overall',shell_name{i},grmsb(i));
    x_label='Frequency (Hz)';
    y_label='Accel (G^2/Hz)';
    fmax=10000;

    [fig_num]=plot_loglog_function_md(fig_num,x_label,y_label,t_string,ppp,fmin,fmax,md);
    
    assignin('base', PSD_name{i}, ppp);

%
end    

%

disp(' ');
disp(' Overall Cylindrical Shell Levels ');
%
out1=sprintf('\n\n Acceleration (up to 2000 Hz) ',grms );
disp(out1)


for i=1:N
    out1=sprintf('  %s  %9.4g GRMS',shell_name{i},grms(i));
    disp(out1);    
end    
    
%
out1=sprintf('\n Acceleration (up to 10,000 Hz) ');
disp(out1)    

for i=1:N
    out1=sprintf('  %s  %9.4g GRMS',shell_name{i},grmsb(i));
    disp(out1);
end
%

disp(' ');
disp(' Output PSD Arrays ');

for i=1:N
   out1=sprintf('  %s ',PSD_name{i});
   disp(out1);
end

disp(' ');

msgbox('Calculation Complete');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




function edit_output_array_name_Callback(hObject, eventdata, handles)
% hObject    handle to edit_output_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_output_array_name as text
%        str2double(get(hObject,'String')) returns contents of edit_output_array_name as a double


% --- Executes during object creation, after setting all properties.
function edit_output_array_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_output_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data=getappdata(0,'Wa');

output_name=get(handles.edit_output_array_name,'String');
assignin('base', output_name, data);


output_filename1=sprintf('%s.txt',output_name);

save(output_filename1,'data','-ASCII')

out1=sprintf('\n Data also written to text file:  %s \n',output_filename1);
disp(out1);


h = msgbox('Save Complete'); 


% --- Executes on selection change in listbox_units.
function listbox_units_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_units (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_units contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_units
change_materials_units(hObject, eventdata, handles);



% --- Executes during object creation, after setting all properties.
function listbox_units_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_units (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_input_array_name_Callback(hObject, eventdata, handles)
% hObject    handle to edit_input_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_input_array_name as text
%        str2double(get(hObject,'String')) returns contents of edit_input_array_name as a double


% --- Executes during object creation, after setting all properties.
function edit_input_array_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_input_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_material.
function listbox_material_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_material (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_material contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_material
change_materials_units(hObject, eventdata, handles);


function change_materials_units(hObject, eventdata, handles)
%

iu=get(handles.listbox_units,'Value');

Nrows=get(handles.listbox_num,'Value');
Ncolumns=6;

if(iu==1)
    headers1={'Shell Name','One-Third Octave SPL','Ring Freq (Hz)','Diameter (in)','Density (lbm/ft^2)','Output PSD Name'};
else
    headers1={'Shell Name','Ring Freq (Hz)','Diameter (m)','Density (kg/m^2)','Output PSD Name'};  
end    
    
set(handles.uitable_data,'Data',cell(Nrows,Ncolumns),'ColumnName',headers1);


% --- Executes during object creation, after setting all properties.
function listbox_material_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_material (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_E_Callback(hObject, eventdata, handles)
% hObject    handle to edit_E (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_E as text
%        str2double(get(hObject,'String')) returns contents of edit_E as a double


% --- Executes during object creation, after setting all properties.
function edit_E_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_E (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_W_Callback(hObject, eventdata, handles)
% hObject    handle to edit_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_W as text
%        str2double(get(hObject,'String')) returns contents of edit_W as a double


% --- Executes during object creation, after setting all properties.
function edit_W_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_diameter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_diameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_diameter as text
%        str2double(get(hObject,'String')) returns contents of edit_diameter as a double


% --- Executes during object creation, after setting all properties.
function edit_diameter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_diameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_thickness_Callback(hObject, eventdata, handles)
% hObject    handle to edit_thickness (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_thickness as text
%        str2double(get(hObject,'String')) returns contents of edit_thickness as a double


% --- Executes during object creation, after setting all properties.
function edit_thickness_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_thickness (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_ring_frequency_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ring_frequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_ring_frequency as text
%        str2double(get(hObject,'String')) returns contents of edit_ring_frequency as a double


% --- Executes during object creation, after setting all properties.
function edit_ring_frequency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ring_frequency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on edit_input_array_name and none of its controls.
function edit_input_array_name_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_input_array_name (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on key press with focus on edit_E and none of its controls.
function edit_E_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_E (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on key press with focus on edit_W and none of its controls.
function edit_W_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_W (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on key press with focus on edit_diameter and none of its controls.
function edit_diameter_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_diameter (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on key press with focus on edit_thickness and none of its controls.
function edit_thickness_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_thickness (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on selection change in listbox_smd.
function listbox_smd_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_smd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_smd contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_smd



% --- Executes during object creation, after setting all properties.
function listbox_smd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_smd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function get_table_data(hObject, eventdata, handles)

A=char(get(handles.uitable_data,'Data'));

N=get(handles.listbox_num,'Value');

fring=zeros(N,1);
diam=zeros(N,1);
smd=zeros(N,1);

k=1;

for i=1:N
    shell_name{i}=A(k,:); k=k+1;
    shell_name{i} = strtrim(shell_name{i});
end

for i=1:N
    SPL_name{i}=A(k,:); k=k+1;
    SPL_name{i} = strtrim(SPL_name{i});
end

for i=1:N
    fring(i)=str2double(A(k,:)); k=k+1;
end

for i=1:N
    diam(i)=str2double(A(k,:)); k=k+1;
end

for i=1:N
    smd(i)=str2double(A(k,:)); k=k+1;
end

for i=1:N
    PSD_name{i}=A(k,:); k=k+1;
    PSD_name{i} = strtrim(PSD_name{i});
end



setappdata(0,'shell_name',shell_name);
setappdata(0,'SPL_name',SPL_name);
setappdata(0,'fring',fring);
setappdata(0,'diam',diam);
setappdata(0,'smd',smd);
setappdata(0,'PSD_name',PSD_name);



% --- Executes on button press in pushbutton_save_model.
function pushbutton_save_model_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save_model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

iu=get(handles.listbox_units,'Value');
Franken_multiple.iu=iu;

num=get(handles.listbox_num,'Value');
Franken_multiple.num=num;

get_table_data(hObject, eventdata, handles);

shell_name=getappdata(0,'shell_name');
SPL_name=getappdata(0,'SPL_name');
fring=getappdata(0,'fring');
diam=getappdata(0,'diam');
smd=getappdata(0,'smd');
PSD_name=getappdata(0,'PSD_name');


Franken_multiple.shell_name=shell_name;
Franken_multiple.SPL_name=SPL_name;
Franken_multiple.fring=fring;
Franken_multiple.diam=diam;
Franken_multiple.smd=smd;
Franken_multiple.PSD_name=PSD_name;


N=num;

for i=1:N
    try
        
        if(i==1)
            THM1=evalin('base',SPL_name{i});
            Franken_multiple.THM1=THM1;
        end
        if(i==2)
            THM2=evalin('base',SPL_name{i});
            Franken_multiple.THM2=THM2;
        end        
        if(i==3)
            THM3=evalin('base',SPL_name{i});
            Franken_multiple.THM3=THM3;
        end
        if(i==4)
            THM4=evalin('base',SPL_name{i});
            Franken_multiple.THM4=THM4;
        end                
        
    catch
    end
end


% % %
 
structnames = fieldnames(Franken_multiple, '-full'); % fields in the struct
  
% % %
 
   [writefname, writepname] = uiputfile('*.mat','Save data as');
 
   %%%    writepfname = fullfile(writepname, writefname);
    
%%%    pattern = '.mat';
%%%    replacement = '';
%%%    sname=regexprep(writefname,pattern,replacement);
   
    elk=sprintf('%s%s',writepname,writefname);
 
    try
 
        save(elk, 'Franken_multiple'); 
 
    catch
        warndlg('Save error');
        return;
    end
 
%%% SSS=load(elk)
 
%%%%%%%%%%
%%%%%%%%%%
 
% Construct a questdlg with four options
choice = questdlg('Save Complete.  Reset Workspace?', ...
    'Options', ...
    'Yes','No','No');
% Handle response
switch choice
    case 'Yes'
%%        disp([choice ' Reseting'])
%%        pushbutton_reset_Callback(hObject, eventdata, handles)
        appdata = get(0,'ApplicationData');
        fnsx = fieldnames(appdata);
        for ii = 1:numel(fnsx)
            rmappdata(0,fnsx{ii});
        end
end  



% --- Executes on button press in pushbutton_load_model.
function pushbutton_load_model_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_load_model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

disp(' ref 1');
 
[filename, pathname] = uigetfile('*.mat');
 
NAME = [pathname,filename];
 
struct=load(NAME);
structnames = fieldnames(struct, '-full'); % fields in the struct
 
disp(' ref 2');
 
k=length(structnames);
 
for i=1:k
    namevar=strcat('struct.',structnames{i});
    value=eval(namevar);
    assignin('base',structnames{i},value);
end
 
disp(' ref 3');
 
structnames
 
 
% struct
 
try
    Franken_multiple=evalin('base','Franken_multiple');
catch
    warndlg(' evalin failed ');
    return;
end
 
Franken_multiple
 
try
    iu=Franken_multiple.iu;    
    set(handles.listbox_units,'Value',iu);
catch
end
 
try
    num=Franken_multiple.num;    
    set(handles.listbox_num,'Value',num);
catch
end


try
    shell_name=Franken_multiple.shell_name;
catch
end

try
    SPL_name=Franken_multiple.SPL_name;
catch
end

try
    fring=Franken_multiple.fring;
catch
end

try
    diam=Franken_multiple.diam;  
catch
end

try
    smd=Franken_multiple.smd;
catch
end

try
    PSD_name=Franken_multiple.PSD_name;   
catch
end

%%%%%%%%%%%%%%%%%%%%%%%

change_materials_units(hObject, eventdata, handles);

try    
    
    N=num;
    
    for i = 1:N

        data_s{i,1}=shell_name{i};
        data_s{i,2}=SPL_name{i};
        
        data_s{i,3}=sprintf('%g',fring(i));
        data_s{i,4}=sprintf('%g',diam(i));
        data_s{i,5}=sprintf('%g',smd(i));
        
        data_s{i,6}=PSD_name{i};
    end
    
catch    
    
    disp('data_s unsuccessful');
end  


try
    set(handles.uitable_data,'Data',data_s);     
catch
    disp('set unsuccessful')
end    
    
    
   


 


% --- Executes on selection change in listbox_num.
function listbox_num_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_num contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_num

change_materials_units(hObject, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function listbox_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
